<?php

defined('_JEXEC') or die();

jimport('joomla.application.component.controller');

class FlashMenuController extends JController
{
	function __construct()
	{
		parent::__construct();
		$this->registerTask('add', 'edit');
		$this->registerTask('unpublish', 'publish');
	}
	
	function saveEditIcon()
	{
		$option = JRequest::getCmd('option');
		$this->setRedirect("index2.php?option=".$option."&act=menu");
		
		$post = JRequest::get('post');
		
		$db	=& JFactory::getDBO();
		$db->setQuery("UPDATE #__flashmenu SET image='".$post['image']."', tooltip='".$post['tooltip']."', content='".$post['content']."', action='".$post['action']."', published='".$post['published']."' WHERE id ='" .$post['id']."'");
		if (!$db->query()) {
				JError::raiseWarning( 500, $db->getError());
		}
		else{
			
			$this->setMessage('Icon Saved');
		}
		$this->createIconsXml();
	}
	
	
	function publish()
	{
		$option = JRequest::getCmd('option');
		
		$cid = JRequest::getVar('cid', array(), 'request', 'array');
		
		if ($this->getTask() == 'publish') {
			$publish = 1;
		} else {
			$publish = 0;
		}

		$db	=& JFactory::getDBO();
		
		$db->setQuery( "UPDATE #__flashmenu SET published='".$publish."'"
		. "\nWHERE id IN (" . implode( ',', $cid ).")");
		if (!$db->query()) {
				JError::raiseWarning( 500, $db->getError() );
			}
		$action="&act=menu";
		
		$this->createIconsXml();
		
		$this->setRedirect('index.php?option=' . $option.$action);
		
		if (count($cid) > 1) {
			$s = 's';
		} else {
			$s = '';
		}
		
		$action = ucfirst($this->getTask()) . 'ed';
		
		$this->setMessage('Icon' . $s . ' ' . $action);
	}
		
	function createIconsXml(){
		$db	=& JFactory::getDBO();
		$db->setQuery("SELECT * FROM #__flashmenu WHERE published='1' ORDER BY ordering");
		$rows = $db->loadObjectList();
		
		$db->setQuery("SELECT * FROM #__flashmenu_config WHERE id='1'");
		$confs = $db->loadObjectList();
		$conf=$confs[0];
		$write_string="<icons iconsize='$conf->iconsize' hspacing='$conf->hspacing' vspacing='$conf->vspacing' x='$conf->x' y='$conf->y' >\n";	
	
		foreach($rows as $row)
		{
			$write_string .= "\t<icon image='$row->image' tooltip='$row->tooltip' content='$row->content' action='$row->action'/>\r\n";
		}
		$write_string.="</icons>";
		if(file_exists('../modules/mod_flashmenu/icons.xml'))
			unlink('../modules/mod_flashmenu/icons.xml');
		$fp=fopen('../modules/mod_flashmenu/icons.xml','w');
		fwrite($fp, $write_string) or die("Error writing to file");
		fclose($fp);
	}
	
	function uploadIcon(){
		$option = JRequest::getCmd('option');
		require_once(JPATH_COMPONENT.DS.'admin.flashmenu.html.php');
		HTML_FlashMenu::upload($option);
	}
		
	function listIcons(){
		$option = JRequest::getCmd('option');
		
		$db	=& JFactory::getDBO();
		$db->setQuery("SELECT * FROM #__flashmenu ORDER BY ordering");
		$rows = $db->loadObjectList();
		
		require_once(JPATH_COMPONENT.DS.'admin.flashmenu.html.php');
		HTML_FlashMenu::listIcons($option, $rows);
	
	}
		
	function newIcon(){
		$option = JRequest::getCmd('option');
		$db	=& JFactory::getDBO();
		$db->setQuery("SELECT * FROM #__content");
		$rows = $db->loadObjectList();
		
		require_once(JPATH_COMPONENT.DS.'admin.flashmenu.html.php');
		HTML_FlashMenu::newIcon($option,$rows);
	}
	
	function saveNewIcon($option){
		$option = JRequest::getCmd('option');
		$post = JRequest::get('post');
		
		$same=false;
		
		$db	=& JFactory::getDBO();
		$db->setQuery("SELECT * FROM #__flashmenu");
		$rows = $db->loadObjectList();
		for($i=0;$i<count($rows);$i++){
			if($row->image==$post['image'])
				$same=true;
		}
		if ($same){
			$this->setRedirect("index2.php?option=".$option."&act=menu&task=newIcon");
			JError::raiseWarning( 500, "File with this name allready exist");
		}
		else{
			$db->setQuery("SELECT * FROM #__flashmenu ORDER BY ordering DESC LIMIT 1");
			$rows = $db->loadObjectList();
			$row=$rows[0];
			$order=$row->ordering+1;
			$db->setQuery("INSERT INTO #__flashmenu VALUES (NULL,'".$post['image']."','".$post['tooltip']."','".$post['content']."','".$post['action']."','".$order."','".$post['published']."')");
			if (!$db->query()) {
				JError::raiseWarning( 500, $db->getError() );
			}
			$this->setRedirect("index2.php?option=".$option."&act=menu");
			$this->setMessage('Success');
		}
		$this->createIconsXml();
	}
	
	function deleteIcon(){
		$option = JRequest::getCmd('option');
		$db	=& JFactory::getDBO();
		$cid = JRequest::getVar('cid', array(), 'request', 'array');

		for ($i=0;$i<count($cid);$i++){
			$db->setQuery("SELECT * FROM #__flashmenu WHERE id = '".$cid[$i]."'");
			$rows = $db->loadObjectList();
			$row=$rows[0];
			if(file_exists('../modules/mod_flashmenu/'.$row->image)){
				unlink('../modules/mod_flashmenu/'.$row->image);
			}
			
			$db->setQuery("DELETE FROM #__flashmenu WHERE id = '".$cid[$i]."'");
			if (!$db->query()) {
				JError::raiseWarning( 500, $db->getError() );
			}
		}
		$this->createIconsXml();
		$this->setRedirect("index2.php?option=".$option."&act=menu");
		$this->setMessage('Success deleted');
			
	}
	
	function editIcon(){
		$option = JRequest::getCmd('option');
		$db	=& JFactory::getDBO();
		$cid = JRequest::getVar('cid', array(), 'request', 'array');
		
		$db->setQuery("SELECT * FROM #__flashmenu WHERE id='".$cid[0]."'");
		$rows = $db->loadObjectList();
		
		$db->setQuery("SELECT * FROM #__content");
		$conts = $db->loadObjectList();
		
		require_once(JPATH_COMPONENT.DS.'admin.flashmenu.html.php');
		HTML_FlashMenu::editIcon($option, $rows,$conts);
	}
			
	function orderUp(){
		$option = JRequest::getCmd('option');
		$db	=& JFactory::getDBO();
		$cid = JRequest::getVar('cid', array(), 'request', 'array');
		$db->setQuery("SELECT * FROM #__flashmenu WHERE id='".$cid[0]."'");
		$rows = $db->loadObjectList();
		$row=$rows[0];
		$current=$row->ordering;
		$newValue=$current-1;
		
		$db->setQuery("UPDATE #__flashmenu SET ordering='".$current."' WHERE ordering='".$newValue."'");
		if (!$db->query()) {
			JError::raiseWarning( 500, $db->getError() );
		}
		
		$db->setQuery("UPDATE #__flashmenu SET ordering='".$newValue."' WHERE id='".$cid[0]."'");
		if (!$db->query()) {
			JError::raiseWarning( 500, $db->getError() );
		}
		$this->setRedirect("index2.php?option=".$option."&act=menu");
		
	}

	function orderDown(){
		$option = JRequest::getCmd('option');
		$db	=& JFactory::getDBO();
		$cid = JRequest::getVar('cid', array(), 'request', 'array');
		$db->setQuery("SELECT * FROM #__flashmenu WHERE id='".$cid[0]."'");
		$rows = $db->loadObjectList();
		$row=$rows[0];
		$current=$row->ordering;
		$newValue=$current+1;
		$db->setQuery("UPDATE #__flashmenu SET ordering='".$current."' WHERE ordering='".$newValue."'");
		if (!$db->query()) {
			JError::raiseWarning( 500, $db->getError() );
		}
			
		$db->setQuery("UPDATE #__flashmenu SET ordering='".$newValue."' WHERE id='".$cid[0]."'");
		if (!$db->query()) {
			JError::raiseWarning( 500, $db->getError() );
		}
		$this->setRedirect("index2.php?option=".$option."&act=menu");
	}

	function saveOrder($option,$cid){
		$option = JRequest::getCmd('option');
		$db	=& JFactory::getDBO();
		$cid = JRequest::getVar('cid', array(), 'request', 'array');
		
		$order=$_REQUEST['order'];
		
		for($i=0;$i<count($cid);$i++){
			$db->setQuery("UPDATE #__flashmenu SET ordering='".$order[$i]."' WHERE id='".$cid[$i]."'");
			if (!$db->query()) {
				JError::raiseWarning( 500, $db->getError() );
			}
		}
		$this->setRedirect("index2.php?option=".$option."&act=menu");
		
	}

	function config(){
		$option = JRequest::getCmd('option');
		$db	=& JFactory::getDBO();
			
		$db->setQuery("SELECT * FROM #__flashmenu_config WHERE id='1'");
		$rows = $db->loadObjectList();
		
		require_once(JPATH_COMPONENT.DS.'admin.flashmenu.html.php');
		HTML_FlashMenu::config($option, $rows[0]);	
	}
	
	function saveConfig(){
		$option = JRequest::getCmd('option');
		$db	=& JFactory::getDBO();
		$post = JRequest::get('post');		
		
		$db->setQuery("UPDATE #__flashmenu_config SET iconsize='".$post['iconsize']."', vspacing='".$post['vspacing']."', hspacing='".$post['hspacing']."',x='".$post['x']."', y='".$post['y']."', frameborder='".$post['frameborder']."' WHERE id='1'");
		if (!$db->query()) {
			JError::raiseWarning( 500, $db->getError() );
			$this->setRedirect("index2.php?option=".$option."&act=menu&task=config");
		}
		else{
			$this->createIconsXml();
			$this->setRedirect("index2.php?option=".$option."&act=menu");
			$this->setMessage('Configuration saved');
			
		}
			
	}
}

?>